/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-21 at 00:31:46 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.pagespeedonline.model;

/**
 * Model definition for Result.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the PageSpeed Insights API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Result extends com.google.api.client.json.GenericJson {

  /**
   * Localized Page Speed results. Contains a ruleResults entry for each Page Speed rule
   * instantiated and run by the server.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private FormattedResults formattedResults;

  /**
   * Canonicalized and final URL for the document, after following page redirects (if any).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * List of rules that were specified in the request, but which the server did not know how to
   * instantiate.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> invalidRules;

  /**
   * Kind of result.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Summary statistics for the page, such as number of JavaScript bytes, number of HTML bytes, etc.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private PageStats pageStats;

  /**
   * Echo of certain request parameters.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Request request;

  /**
   * Response code for the document. 200 indicates a normal page load. 4xx/5xx indicates an error.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer responseCode;

  /**
   * The Page Speed Score (0-100), which indicates how much faster a page could be. A high score
   * indicates little room for improvement, while a lower score indicates more room for improvement.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer score;

  /**
   * Base64 encoded screenshot of the page that was analyzed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Screenshot screenshot;

  /**
   * Title of the page, as displayed in the browser's title bar.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * The version of the Page Speed SDK used to generate these results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Version version;

  /**
   * Localized Page Speed results. Contains a ruleResults entry for each Page Speed rule
   * instantiated and run by the server.
   * @return value or {@code null} for none
   */
  public FormattedResults getFormattedResults() {
    return formattedResults;
  }

  /**
   * Localized Page Speed results. Contains a ruleResults entry for each Page Speed rule
   * instantiated and run by the server.
   * @param formattedResults formattedResults or {@code null} for none
   */
  public Result setFormattedResults(FormattedResults formattedResults) {
    this.formattedResults = formattedResults;
    return this;
  }

  /**
   * Canonicalized and final URL for the document, after following page redirects (if any).
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Canonicalized and final URL for the document, after following page redirects (if any).
   * @param id id or {@code null} for none
   */
  public Result setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * List of rules that were specified in the request, but which the server did not know how to
   * instantiate.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getInvalidRules() {
    return invalidRules;
  }

  /**
   * List of rules that were specified in the request, but which the server did not know how to
   * instantiate.
   * @param invalidRules invalidRules or {@code null} for none
   */
  public Result setInvalidRules(java.util.List<java.lang.String> invalidRules) {
    this.invalidRules = invalidRules;
    return this;
  }

  /**
   * Kind of result.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of result.
   * @param kind kind or {@code null} for none
   */
  public Result setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Summary statistics for the page, such as number of JavaScript bytes, number of HTML bytes, etc.
   * @return value or {@code null} for none
   */
  public PageStats getPageStats() {
    return pageStats;
  }

  /**
   * Summary statistics for the page, such as number of JavaScript bytes, number of HTML bytes, etc.
   * @param pageStats pageStats or {@code null} for none
   */
  public Result setPageStats(PageStats pageStats) {
    this.pageStats = pageStats;
    return this;
  }

  /**
   * Echo of certain request parameters.
   * @return value or {@code null} for none
   */
  public Request getRequest() {
    return request;
  }

  /**
   * Echo of certain request parameters.
   * @param request request or {@code null} for none
   */
  public Result setRequest(Request request) {
    this.request = request;
    return this;
  }

  /**
   * Response code for the document. 200 indicates a normal page load. 4xx/5xx indicates an error.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getResponseCode() {
    return responseCode;
  }

  /**
   * Response code for the document. 200 indicates a normal page load. 4xx/5xx indicates an error.
   * @param responseCode responseCode or {@code null} for none
   */
  public Result setResponseCode(java.lang.Integer responseCode) {
    this.responseCode = responseCode;
    return this;
  }

  /**
   * The Page Speed Score (0-100), which indicates how much faster a page could be. A high score
   * indicates little room for improvement, while a lower score indicates more room for improvement.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getScore() {
    return score;
  }

  /**
   * The Page Speed Score (0-100), which indicates how much faster a page could be. A high score
   * indicates little room for improvement, while a lower score indicates more room for improvement.
   * @param score score or {@code null} for none
   */
  public Result setScore(java.lang.Integer score) {
    this.score = score;
    return this;
  }

  /**
   * Base64 encoded screenshot of the page that was analyzed.
   * @return value or {@code null} for none
   */
  public Screenshot getScreenshot() {
    return screenshot;
  }

  /**
   * Base64 encoded screenshot of the page that was analyzed.
   * @param screenshot screenshot or {@code null} for none
   */
  public Result setScreenshot(Screenshot screenshot) {
    this.screenshot = screenshot;
    return this;
  }

  /**
   * Title of the page, as displayed in the browser's title bar.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * Title of the page, as displayed in the browser's title bar.
   * @param title title or {@code null} for none
   */
  public Result setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  /**
   * The version of the Page Speed SDK used to generate these results.
   * @return value or {@code null} for none
   */
  public Version getVersion() {
    return version;
  }

  /**
   * The version of the Page Speed SDK used to generate these results.
   * @param version version or {@code null} for none
   */
  public Result setVersion(Version version) {
    this.version = version;
    return this;
  }

  @Override
  public Result set(String fieldName, Object value) {
    return (Result) super.set(fieldName, value);
  }

  @Override
  public Result clone() {
    return (Result) super.clone();
  }

  /**
   * Localized Page Speed results. Contains a ruleResults entry for each Page Speed rule instantiated
   * and run by the server.
   */
  public static final class FormattedResults extends com.google.api.client.json.GenericJson {

    /**
     * The locale of the formattedResults, e.g. "en_US".
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String locale;

    /**
     * Dictionary of formatted rule results, with one entry for each Page Speed rule instantiated and
     * run by the server.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.Map<String, RuleResultsElement> ruleResults;

    static {
      // hack to force ProGuard to consider RuleResultsElement used, since otherwise it would be stripped out
      // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
      com.google.api.client.util.Data.nullOf(RuleResultsElement.class);
    }

    /**
     * The locale of the formattedResults, e.g. "en_US".
     * @return value or {@code null} for none
     */
    public java.lang.String getLocale() {
      return locale;
    }

    /**
     * The locale of the formattedResults, e.g. "en_US".
     * @param locale locale or {@code null} for none
     */
    public FormattedResults setLocale(java.lang.String locale) {
      this.locale = locale;
      return this;
    }

    /**
     * Dictionary of formatted rule results, with one entry for each Page Speed rule instantiated and
     * run by the server.
     * @return value or {@code null} for none
     */
    public java.util.Map<String, RuleResultsElement> getRuleResults() {
      return ruleResults;
    }

    /**
     * Dictionary of formatted rule results, with one entry for each Page Speed rule instantiated and
     * run by the server.
     * @param ruleResults ruleResults or {@code null} for none
     */
    public FormattedResults setRuleResults(java.util.Map<String, RuleResultsElement> ruleResults) {
      this.ruleResults = ruleResults;
      return this;
    }

    @Override
    public FormattedResults set(String fieldName, Object value) {
      return (FormattedResults) super.set(fieldName, value);
    }

    @Override
    public FormattedResults clone() {
      return (FormattedResults) super.clone();
    }

    /**
     * The enum-like identifier for this rule. For instance "EnableKeepAlive" or "AvoidCssImport". Not
     * localized.
     */
    public static final class RuleResultsElement extends com.google.api.client.json.GenericJson {

      /**
       * Localized name of the rule, intended for presentation to a user.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.String localizedRuleName;

      /**
       * The impact (unbounded floating point value) that implementing the suggestions for this rule
       * would have on making the page faster. Impact is comparable between rules to determine which
       * rule's suggestions would have a higher or lower impact on making a page faster. For instance,
       * if enabling compression would save 1MB, while optimizing images would save 500kB, the enable
       * compression rule would have 2x the impact of the image optimization rule, all other things
       * being equal.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.Double ruleImpact;

      /**
       * The score (0-100) for this rule. The rule score indicates how well a page implements the
       * recommendations for the given rule. For instance, if none of the compressible resources on a
       * page are compressed, the rule score would be 0, while if all of the compressible resources on a
       * page are compressed, the rule score would be 100.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.Integer ruleScore;

      /**
       * List of blocks of URLs. Each block may contain a heading and a list of URLs. Each URL may
       * optionally include additional details.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.util.List<UrlBlocks> urlBlocks;

      static {
        // hack to force ProGuard to consider UrlBlocks used, since otherwise it would be stripped out
        // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
        com.google.api.client.util.Data.nullOf(UrlBlocks.class);
      }

      /**
       * Localized name of the rule, intended for presentation to a user.
       * @return value or {@code null} for none
       */
      public java.lang.String getLocalizedRuleName() {
        return localizedRuleName;
      }

      /**
       * Localized name of the rule, intended for presentation to a user.
       * @param localizedRuleName localizedRuleName or {@code null} for none
       */
      public RuleResultsElement setLocalizedRuleName(java.lang.String localizedRuleName) {
        this.localizedRuleName = localizedRuleName;
        return this;
      }

      /**
       * The impact (unbounded floating point value) that implementing the suggestions for this rule
       * would have on making the page faster. Impact is comparable between rules to determine which
       * rule's suggestions would have a higher or lower impact on making a page faster. For instance,
       * if enabling compression would save 1MB, while optimizing images would save 500kB, the enable
       * compression rule would have 2x the impact of the image optimization rule, all other things
       * being equal.
       * @return value or {@code null} for none
       */
      public java.lang.Double getRuleImpact() {
        return ruleImpact;
      }

      /**
       * The impact (unbounded floating point value) that implementing the suggestions for this rule
       * would have on making the page faster. Impact is comparable between rules to determine which
       * rule's suggestions would have a higher or lower impact on making a page faster. For instance,
       * if enabling compression would save 1MB, while optimizing images would save 500kB, the enable
       * compression rule would have 2x the impact of the image optimization rule, all other things
       * being equal.
       * @param ruleImpact ruleImpact or {@code null} for none
       */
      public RuleResultsElement setRuleImpact(java.lang.Double ruleImpact) {
        this.ruleImpact = ruleImpact;
        return this;
      }

      /**
       * The score (0-100) for this rule. The rule score indicates how well a page implements the
       * recommendations for the given rule. For instance, if none of the compressible resources on a
       * page are compressed, the rule score would be 0, while if all of the compressible resources on a
       * page are compressed, the rule score would be 100.
       * @return value or {@code null} for none
       */
      public java.lang.Integer getRuleScore() {
        return ruleScore;
      }

      /**
       * The score (0-100) for this rule. The rule score indicates how well a page implements the
       * recommendations for the given rule. For instance, if none of the compressible resources on a
       * page are compressed, the rule score would be 0, while if all of the compressible resources on a
       * page are compressed, the rule score would be 100.
       * @param ruleScore ruleScore or {@code null} for none
       */
      public RuleResultsElement setRuleScore(java.lang.Integer ruleScore) {
        this.ruleScore = ruleScore;
        return this;
      }

      /**
       * List of blocks of URLs. Each block may contain a heading and a list of URLs. Each URL may
       * optionally include additional details.
       * @return value or {@code null} for none
       */
      public java.util.List<UrlBlocks> getUrlBlocks() {
        return urlBlocks;
      }

      /**
       * List of blocks of URLs. Each block may contain a heading and a list of URLs. Each URL may
       * optionally include additional details.
       * @param urlBlocks urlBlocks or {@code null} for none
       */
      public RuleResultsElement setUrlBlocks(java.util.List<UrlBlocks> urlBlocks) {
        this.urlBlocks = urlBlocks;
        return this;
      }

      @Override
      public RuleResultsElement set(String fieldName, Object value) {
        return (RuleResultsElement) super.set(fieldName, value);
      }

      @Override
      public RuleResultsElement clone() {
        return (RuleResultsElement) super.clone();
      }

      /**
       * Model definition for ResultFormattedResultsRuleResultsElementUrlBlocks.
       */
      public static final class UrlBlocks extends com.google.api.client.json.GenericJson {

        /**
         * Heading to be displayed with the list of URLs.
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private Header header;

        /**
         * List of entries that provide information about URLs in the url block. Optional.
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private java.util.List<Urls> urls;

        static {
          // hack to force ProGuard to consider Urls used, since otherwise it would be stripped out
          // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
          com.google.api.client.util.Data.nullOf(Urls.class);
        }

        /**
         * Heading to be displayed with the list of URLs.
         * @return value or {@code null} for none
         */
        public Header getHeader() {
          return header;
        }

        /**
         * Heading to be displayed with the list of URLs.
         * @param header header or {@code null} for none
         */
        public UrlBlocks setHeader(Header header) {
          this.header = header;
          return this;
        }

        /**
         * List of entries that provide information about URLs in the url block. Optional.
         * @return value or {@code null} for none
         */
        public java.util.List<Urls> getUrls() {
          return urls;
        }

        /**
         * List of entries that provide information about URLs in the url block. Optional.
         * @param urls urls or {@code null} for none
         */
        public UrlBlocks setUrls(java.util.List<Urls> urls) {
          this.urls = urls;
          return this;
        }

        @Override
        public UrlBlocks set(String fieldName, Object value) {
          return (UrlBlocks) super.set(fieldName, value);
        }

        @Override
        public UrlBlocks clone() {
          return (UrlBlocks) super.clone();
        }

        /**
         * Heading to be displayed with the list of URLs.
         */
        public static final class Header extends com.google.api.client.json.GenericJson {

          /**
           * List of arguments for the format string.
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private java.util.List<Args> args;

          static {
            // hack to force ProGuard to consider Args used, since otherwise it would be stripped out
            // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
            com.google.api.client.util.Data.nullOf(Args.class);
          }

          /**
           * A localized format string with $N placeholders, where N is the 1-indexed argument number, e.g.
           * 'Minifying the following $1 resources would save a total of $2 bytes'.
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private java.lang.String format;

          /**
           * List of arguments for the format string.
           * @return value or {@code null} for none
           */
          public java.util.List<Args> getArgs() {
            return args;
          }

          /**
           * List of arguments for the format string.
           * @param args args or {@code null} for none
           */
          public Header setArgs(java.util.List<Args> args) {
            this.args = args;
            return this;
          }

          /**
           * A localized format string with $N placeholders, where N is the 1-indexed argument number, e.g.
           * 'Minifying the following $1 resources would save a total of $2 bytes'.
           * @return value or {@code null} for none
           */
          public java.lang.String getFormat() {
            return format;
          }

          /**
           * A localized format string with $N placeholders, where N is the 1-indexed argument number, e.g.
           * 'Minifying the following $1 resources would save a total of $2 bytes'.
           * @param format format or {@code null} for none
           */
          public Header setFormat(java.lang.String format) {
            this.format = format;
            return this;
          }

          @Override
          public Header set(String fieldName, Object value) {
            return (Header) super.set(fieldName, value);
          }

          @Override
          public Header clone() {
            return (Header) super.clone();
          }

          /**
           * Model definition for ResultFormattedResultsRuleResultsElementUrlBlocksHeaderArgs.
           */
          public static final class Args extends com.google.api.client.json.GenericJson {

            /**
             * Type of argument. One of URL, STRING_LITERAL, INT_LITERAL, BYTES, or DURATION.
             * The value may be {@code null}.
             */
            @com.google.api.client.util.Key
            private java.lang.String type;

            /**
             * Argument value, as a localized string.
             * The value may be {@code null}.
             */
            @com.google.api.client.util.Key
            private java.lang.String value;

            /**
             * Type of argument. One of URL, STRING_LITERAL, INT_LITERAL, BYTES, or DURATION.
             * @return value or {@code null} for none
             */
            public java.lang.String getType() {
              return type;
            }

            /**
             * Type of argument. One of URL, STRING_LITERAL, INT_LITERAL, BYTES, or DURATION.
             * @param type type or {@code null} for none
             */
            public Args setType(java.lang.String type) {
              this.type = type;
              return this;
            }

            /**
             * Argument value, as a localized string.
             * @return value or {@code null} for none
             */
            public java.lang.String getValue() {
              return value;
            }

            /**
             * Argument value, as a localized string.
             * @param value value or {@code null} for none
             */
            public Args setValue(java.lang.String value) {
              this.value = value;
              return this;
            }

            @Override
            public Args set(String fieldName, Object value) {
              return (Args) super.set(fieldName, value);
            }

            @Override
            public Args clone() {
              return (Args) super.clone();
            }

          }
        }
        /**
         * Model definition for ResultFormattedResultsRuleResultsElementUrlBlocksUrls.
         */
        public static final class Urls extends com.google.api.client.json.GenericJson {

          /**
           * List of entries that provide additional details about a single URL. Optional.
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private java.util.List<Details> details;

          static {
            // hack to force ProGuard to consider Details used, since otherwise it would be stripped out
            // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
            com.google.api.client.util.Data.nullOf(Details.class);
          }

          /**
           * A format string that gives information about the URL, and a list of arguments for that format
           * string.
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResult result;

          /**
           * List of entries that provide additional details about a single URL. Optional.
           * @return value or {@code null} for none
           */
          public java.util.List<Details> getDetails() {
            return details;
          }

          /**
           * List of entries that provide additional details about a single URL. Optional.
           * @param details details or {@code null} for none
           */
          public Urls setDetails(java.util.List<Details> details) {
            this.details = details;
            return this;
          }

          /**
           * A format string that gives information about the URL, and a list of arguments for that format
           * string.
           * @return value or {@code null} for none
           */
          public ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResult getResult() {
            return result;
          }

          /**
           * A format string that gives information about the URL, and a list of arguments for that format
           * string.
           * @param result result or {@code null} for none
           */
          public Urls setResult(ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResult result) {
            this.result = result;
            return this;
          }

          @Override
          public Urls set(String fieldName, Object value) {
            return (Urls) super.set(fieldName, value);
          }

          @Override
          public Urls clone() {
            return (Urls) super.clone();
          }

          /**
           * Model definition for ResultFormattedResultsRuleResultsElementUrlBlocksUrlsDetails.
           */
          public static final class Details extends com.google.api.client.json.GenericJson {

            /**
             * List of arguments for the format string.
             * The value may be {@code null}.
             */
            @com.google.api.client.util.Key
            private java.util.List<Args> args;

            static {
              // hack to force ProGuard to consider Args used, since otherwise it would be stripped out
              // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
              com.google.api.client.util.Data.nullOf(Args.class);
            }

            /**
             * A localized format string with $N placeholders, where N is the 1-indexed argument number, e.g.
             * 'Unnecessary metadata for this resource adds an additional $1 bytes to its download size'.
             * The value may be {@code null}.
             */
            @com.google.api.client.util.Key
            private java.lang.String format;

            /**
             * List of arguments for the format string.
             * @return value or {@code null} for none
             */
            public java.util.List<Args> getArgs() {
              return args;
            }

            /**
             * List of arguments for the format string.
             * @param args args or {@code null} for none
             */
            public Details setArgs(java.util.List<Args> args) {
              this.args = args;
              return this;
            }

            /**
             * A localized format string with $N placeholders, where N is the 1-indexed argument number, e.g.
             * 'Unnecessary metadata for this resource adds an additional $1 bytes to its download size'.
             * @return value or {@code null} for none
             */
            public java.lang.String getFormat() {
              return format;
            }

            /**
             * A localized format string with $N placeholders, where N is the 1-indexed argument number, e.g.
             * 'Unnecessary metadata for this resource adds an additional $1 bytes to its download size'.
             * @param format format or {@code null} for none
             */
            public Details setFormat(java.lang.String format) {
              this.format = format;
              return this;
            }

            @Override
            public Details set(String fieldName, Object value) {
              return (Details) super.set(fieldName, value);
            }

            @Override
            public Details clone() {
              return (Details) super.clone();
            }

            /**
             * Model definition for ResultFormattedResultsRuleResultsElementUrlBlocksUrlsDetailsArgs.
             */
            public static final class Args extends com.google.api.client.json.GenericJson {

              /**
               * Type of argument. One of URL, STRING_LITERAL, INT_LITERAL, BYTES, or DURATION.
               * The value may be {@code null}.
               */
              @com.google.api.client.util.Key
              private java.lang.String type;

              /**
               * Argument value, as a localized string.
               * The value may be {@code null}.
               */
              @com.google.api.client.util.Key
              private java.lang.String value;

              /**
               * Type of argument. One of URL, STRING_LITERAL, INT_LITERAL, BYTES, or DURATION.
               * @return value or {@code null} for none
               */
              public java.lang.String getType() {
                return type;
              }

              /**
               * Type of argument. One of URL, STRING_LITERAL, INT_LITERAL, BYTES, or DURATION.
               * @param type type or {@code null} for none
               */
              public Args setType(java.lang.String type) {
                this.type = type;
                return this;
              }

              /**
               * Argument value, as a localized string.
               * @return value or {@code null} for none
               */
              public java.lang.String getValue() {
                return value;
              }

              /**
               * Argument value, as a localized string.
               * @param value value or {@code null} for none
               */
              public Args setValue(java.lang.String value) {
                this.value = value;
                return this;
              }

              @Override
              public Args set(String fieldName, Object value) {
                return (Args) super.set(fieldName, value);
              }

              @Override
              public Args clone() {
                return (Args) super.clone();
              }

            }
          }
          /**
           * A format string that gives information about the URL, and a list of arguments for that format
           * string.
           */
          public static final class ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResult extends com.google.api.client.json.GenericJson {

            /**
             * List of arguments for the format string.
             * The value may be {@code null}.
             */
            @com.google.api.client.util.Key
            private java.util.List<Args> args;

            static {
              // hack to force ProGuard to consider Args used, since otherwise it would be stripped out
              // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
              com.google.api.client.util.Data.nullOf(Args.class);
            }

            /**
             * A localized format string with $N placeholders, where N is the 1-indexed argument number, e.g.
             * 'Minifying the resource at URL $1 can save $2 bytes'.
             * The value may be {@code null}.
             */
            @com.google.api.client.util.Key
            private java.lang.String format;

            /**
             * List of arguments for the format string.
             * @return value or {@code null} for none
             */
            public java.util.List<Args> getArgs() {
              return args;
            }

            /**
             * List of arguments for the format string.
             * @param args args or {@code null} for none
             */
            public ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResult setArgs(java.util.List<Args> args) {
              this.args = args;
              return this;
            }

            /**
             * A localized format string with $N placeholders, where N is the 1-indexed argument number, e.g.
             * 'Minifying the resource at URL $1 can save $2 bytes'.
             * @return value or {@code null} for none
             */
            public java.lang.String getFormat() {
              return format;
            }

            /**
             * A localized format string with $N placeholders, where N is the 1-indexed argument number, e.g.
             * 'Minifying the resource at URL $1 can save $2 bytes'.
             * @param format format or {@code null} for none
             */
            public ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResult setFormat(java.lang.String format) {
              this.format = format;
              return this;
            }

            @Override
            public ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResult set(String fieldName, Object value) {
              return (ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResult) super.set(fieldName, value);
            }

            @Override
            public ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResult clone() {
              return (ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResult) super.clone();
            }

            /**
             * Model definition for ResultFormattedResultsRuleResultsElementUrlBlocksUrlsResultArgs.
             */
            public static final class Args extends com.google.api.client.json.GenericJson {

              /**
               * Type of argument. One of URL, STRING_LITERAL, INT_LITERAL, BYTES, or DURATION.
               * The value may be {@code null}.
               */
              @com.google.api.client.util.Key
              private java.lang.String type;

              /**
               * Argument value, as a localized string.
               * The value may be {@code null}.
               */
              @com.google.api.client.util.Key
              private java.lang.String value;

              /**
               * Type of argument. One of URL, STRING_LITERAL, INT_LITERAL, BYTES, or DURATION.
               * @return value or {@code null} for none
               */
              public java.lang.String getType() {
                return type;
              }

              /**
               * Type of argument. One of URL, STRING_LITERAL, INT_LITERAL, BYTES, or DURATION.
               * @param type type or {@code null} for none
               */
              public Args setType(java.lang.String type) {
                this.type = type;
                return this;
              }

              /**
               * Argument value, as a localized string.
               * @return value or {@code null} for none
               */
              public java.lang.String getValue() {
                return value;
              }

              /**
               * Argument value, as a localized string.
               * @param value value or {@code null} for none
               */
              public Args setValue(java.lang.String value) {
                this.value = value;
                return this;
              }

              @Override
              public Args set(String fieldName, Object value) {
                return (Args) super.set(fieldName, value);
              }

              @Override
              public Args clone() {
                return (Args) super.clone();
              }

            }
          }
        }
      }
    }
  }

  /**
   * Summary statistics for the page, such as number of JavaScript bytes, number of HTML bytes, etc.
   */
  public static final class PageStats extends com.google.api.client.json.GenericJson {

    /**
     * Number of uncompressed response bytes for CSS resources on the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long cssResponseBytes;

    /**
     * Number of response bytes for flash resources on the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long flashResponseBytes;

    /**
     * Number of uncompressed response bytes for the main HTML document and all iframes on the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long htmlResponseBytes;

    /**
     * Number of response bytes for image resources on the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long imageResponseBytes;

    /**
     * Number of uncompressed response bytes for JS resources on the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long javascriptResponseBytes;

    /**
     * Number of CSS resources referenced by the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer numberCssResources;

    /**
     * Number of unique hosts referenced by the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer numberHosts;

    /**
     * Number of JavaScript resources referenced by the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer numberJsResources;

    /**
     * Number of HTTP resources loaded by the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer numberResources;

    /**
     * Number of static (i.e. cacheable) resources on the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer numberStaticResources;

    /**
     * Number of response bytes for other resources on the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long otherResponseBytes;

    /**
     * Number of uncompressed response bytes for text resources not covered by other statistics (i.e
     * non-HTML, non-script, non-CSS resources) on the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long textResponseBytes;

    /**
     * Total size of all request bytes sent by the page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long totalRequestBytes;

    /**
     * Number of uncompressed response bytes for CSS resources on the page.
     * @return value or {@code null} for none
     */
    public java.lang.Long getCssResponseBytes() {
      return cssResponseBytes;
    }

    /**
     * Number of uncompressed response bytes for CSS resources on the page.
     * @param cssResponseBytes cssResponseBytes or {@code null} for none
     */
    public PageStats setCssResponseBytes(java.lang.Long cssResponseBytes) {
      this.cssResponseBytes = cssResponseBytes;
      return this;
    }

    /**
     * Number of response bytes for flash resources on the page.
     * @return value or {@code null} for none
     */
    public java.lang.Long getFlashResponseBytes() {
      return flashResponseBytes;
    }

    /**
     * Number of response bytes for flash resources on the page.
     * @param flashResponseBytes flashResponseBytes or {@code null} for none
     */
    public PageStats setFlashResponseBytes(java.lang.Long flashResponseBytes) {
      this.flashResponseBytes = flashResponseBytes;
      return this;
    }

    /**
     * Number of uncompressed response bytes for the main HTML document and all iframes on the page.
     * @return value or {@code null} for none
     */
    public java.lang.Long getHtmlResponseBytes() {
      return htmlResponseBytes;
    }

    /**
     * Number of uncompressed response bytes for the main HTML document and all iframes on the page.
     * @param htmlResponseBytes htmlResponseBytes or {@code null} for none
     */
    public PageStats setHtmlResponseBytes(java.lang.Long htmlResponseBytes) {
      this.htmlResponseBytes = htmlResponseBytes;
      return this;
    }

    /**
     * Number of response bytes for image resources on the page.
     * @return value or {@code null} for none
     */
    public java.lang.Long getImageResponseBytes() {
      return imageResponseBytes;
    }

    /**
     * Number of response bytes for image resources on the page.
     * @param imageResponseBytes imageResponseBytes or {@code null} for none
     */
    public PageStats setImageResponseBytes(java.lang.Long imageResponseBytes) {
      this.imageResponseBytes = imageResponseBytes;
      return this;
    }

    /**
     * Number of uncompressed response bytes for JS resources on the page.
     * @return value or {@code null} for none
     */
    public java.lang.Long getJavascriptResponseBytes() {
      return javascriptResponseBytes;
    }

    /**
     * Number of uncompressed response bytes for JS resources on the page.
     * @param javascriptResponseBytes javascriptResponseBytes or {@code null} for none
     */
    public PageStats setJavascriptResponseBytes(java.lang.Long javascriptResponseBytes) {
      this.javascriptResponseBytes = javascriptResponseBytes;
      return this;
    }

    /**
     * Number of CSS resources referenced by the page.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getNumberCssResources() {
      return numberCssResources;
    }

    /**
     * Number of CSS resources referenced by the page.
     * @param numberCssResources numberCssResources or {@code null} for none
     */
    public PageStats setNumberCssResources(java.lang.Integer numberCssResources) {
      this.numberCssResources = numberCssResources;
      return this;
    }

    /**
     * Number of unique hosts referenced by the page.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getNumberHosts() {
      return numberHosts;
    }

    /**
     * Number of unique hosts referenced by the page.
     * @param numberHosts numberHosts or {@code null} for none
     */
    public PageStats setNumberHosts(java.lang.Integer numberHosts) {
      this.numberHosts = numberHosts;
      return this;
    }

    /**
     * Number of JavaScript resources referenced by the page.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getNumberJsResources() {
      return numberJsResources;
    }

    /**
     * Number of JavaScript resources referenced by the page.
     * @param numberJsResources numberJsResources or {@code null} for none
     */
    public PageStats setNumberJsResources(java.lang.Integer numberJsResources) {
      this.numberJsResources = numberJsResources;
      return this;
    }

    /**
     * Number of HTTP resources loaded by the page.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getNumberResources() {
      return numberResources;
    }

    /**
     * Number of HTTP resources loaded by the page.
     * @param numberResources numberResources or {@code null} for none
     */
    public PageStats setNumberResources(java.lang.Integer numberResources) {
      this.numberResources = numberResources;
      return this;
    }

    /**
     * Number of static (i.e. cacheable) resources on the page.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getNumberStaticResources() {
      return numberStaticResources;
    }

    /**
     * Number of static (i.e. cacheable) resources on the page.
     * @param numberStaticResources numberStaticResources or {@code null} for none
     */
    public PageStats setNumberStaticResources(java.lang.Integer numberStaticResources) {
      this.numberStaticResources = numberStaticResources;
      return this;
    }

    /**
     * Number of response bytes for other resources on the page.
     * @return value or {@code null} for none
     */
    public java.lang.Long getOtherResponseBytes() {
      return otherResponseBytes;
    }

    /**
     * Number of response bytes for other resources on the page.
     * @param otherResponseBytes otherResponseBytes or {@code null} for none
     */
    public PageStats setOtherResponseBytes(java.lang.Long otherResponseBytes) {
      this.otherResponseBytes = otherResponseBytes;
      return this;
    }

    /**
     * Number of uncompressed response bytes for text resources not covered by other statistics (i.e
     * non-HTML, non-script, non-CSS resources) on the page.
     * @return value or {@code null} for none
     */
    public java.lang.Long getTextResponseBytes() {
      return textResponseBytes;
    }

    /**
     * Number of uncompressed response bytes for text resources not covered by other statistics (i.e
     * non-HTML, non-script, non-CSS resources) on the page.
     * @param textResponseBytes textResponseBytes or {@code null} for none
     */
    public PageStats setTextResponseBytes(java.lang.Long textResponseBytes) {
      this.textResponseBytes = textResponseBytes;
      return this;
    }

    /**
     * Total size of all request bytes sent by the page.
     * @return value or {@code null} for none
     */
    public java.lang.Long getTotalRequestBytes() {
      return totalRequestBytes;
    }

    /**
     * Total size of all request bytes sent by the page.
     * @param totalRequestBytes totalRequestBytes or {@code null} for none
     */
    public PageStats setTotalRequestBytes(java.lang.Long totalRequestBytes) {
      this.totalRequestBytes = totalRequestBytes;
      return this;
    }

    @Override
    public PageStats set(String fieldName, Object value) {
      return (PageStats) super.set(fieldName, value);
    }

    @Override
    public PageStats clone() {
      return (PageStats) super.clone();
    }

  }

  /**
   * Echo of certain request parameters.
   */
  public static final class Request extends com.google.api.client.json.GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key("filter_third_party_resources")
    private java.lang.String filterThirdPartyResources;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String strategy;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String url;

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getFilterThirdPartyResources() {
      return filterThirdPartyResources;
    }

    /**
     * @param filterThirdPartyResources filterThirdPartyResources or {@code null} for none
     */
    public Request setFilterThirdPartyResources(java.lang.String filterThirdPartyResources) {
      this.filterThirdPartyResources = filterThirdPartyResources;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getStrategy() {
      return strategy;
    }

    /**
     * @param strategy strategy or {@code null} for none
     */
    public Request setStrategy(java.lang.String strategy) {
      this.strategy = strategy;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getUrl() {
      return url;
    }

    /**
     * @param url url or {@code null} for none
     */
    public Request setUrl(java.lang.String url) {
      this.url = url;
      return this;
    }

    @Override
    public Request set(String fieldName, Object value) {
      return (Request) super.set(fieldName, value);
    }

    @Override
    public Request clone() {
      return (Request) super.clone();
    }

  }

  /**
   * Base64 encoded screenshot of the page that was analyzed.
   */
  public static final class Screenshot extends com.google.api.client.json.GenericJson {

    /**
     * Image data base64 encoded.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String data;

    /**
     * Height of screenshot in pixels.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer height;

    /**
     * Mime type of image data. E.g. "image/jpeg".
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key("mime_type")
    private java.lang.String mimeType;

    /**
     * Width of screenshot in pixels.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer width;

    /**
     * Image data base64 encoded.
     * @see #decodeData()
     * @return value or {@code null} for none
     */
    public java.lang.String getData() {
      return data;
    }

    /**
     * Image data base64 encoded.
     * @see #getData()
     * @return Base64 decoded value or {@code null} for none
     *
     * @since 1.14
     */
    public byte[] decodeData() {
      return com.google.api.client.util.Base64.decodeBase64(data);
    }

    /**
     * Image data base64 encoded.
     * @see #encodeData()
     * @param data data or {@code null} for none
     */
    public Screenshot setData(java.lang.String data) {
      this.data = data;
      return this;
    }

    /**
     * Image data base64 encoded.
     * @see #setData()
     *
     * <p>
     * The value is encoded Base64 or {@code null} for none.
     * </p>
     *
     * @since 1.14
     */
    public Screenshot encodeData(byte[] data) {
      this.data = com.google.api.client.util.Base64.encodeBase64URLSafeString(data);
      return this;
    }

    /**
     * Height of screenshot in pixels.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getHeight() {
      return height;
    }

    /**
     * Height of screenshot in pixels.
     * @param height height or {@code null} for none
     */
    public Screenshot setHeight(java.lang.Integer height) {
      this.height = height;
      return this;
    }

    /**
     * Mime type of image data. E.g. "image/jpeg".
     * @return value or {@code null} for none
     */
    public java.lang.String getMimeType() {
      return mimeType;
    }

    /**
     * Mime type of image data. E.g. "image/jpeg".
     * @param mimeType mimeType or {@code null} for none
     */
    public Screenshot setMimeType(java.lang.String mimeType) {
      this.mimeType = mimeType;
      return this;
    }

    /**
     * Width of screenshot in pixels.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getWidth() {
      return width;
    }

    /**
     * Width of screenshot in pixels.
     * @param width width or {@code null} for none
     */
    public Screenshot setWidth(java.lang.Integer width) {
      this.width = width;
      return this;
    }

    @Override
    public Screenshot set(String fieldName, Object value) {
      return (Screenshot) super.set(fieldName, value);
    }

    @Override
    public Screenshot clone() {
      return (Screenshot) super.clone();
    }

  }

  /**
   * The version of the Page Speed SDK used to generate these results.
   */
  public static final class Version extends com.google.api.client.json.GenericJson {

    /**
     * The major version number of the Page Speed SDK used to generate these results.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer major;

    /**
     * The minor version number of the Page Speed SDK used to generate these results.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer minor;

    /**
     * The major version number of the Page Speed SDK used to generate these results.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getMajor() {
      return major;
    }

    /**
     * The major version number of the Page Speed SDK used to generate these results.
     * @param major major or {@code null} for none
     */
    public Version setMajor(java.lang.Integer major) {
      this.major = major;
      return this;
    }

    /**
     * The minor version number of the Page Speed SDK used to generate these results.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getMinor() {
      return minor;
    }

    /**
     * The minor version number of the Page Speed SDK used to generate these results.
     * @param minor minor or {@code null} for none
     */
    public Version setMinor(java.lang.Integer minor) {
      this.minor = minor;
      return this;
    }

    @Override
    public Version set(String fieldName, Object value) {
      return (Version) super.set(fieldName, value);
    }

    @Override
    public Version clone() {
      return (Version) super.clone();
    }

  }
}
